unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MPlayer, StdCtrls, ExtCtrls, ComCtrls, Menus, ID3Engine;

type
  TTrackBarM = class(TTrackBar)
   private
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
   public
    Promene: boolean;
  end;
  TForm1 = class(TForm)
    MediaPlayer1: TMediaPlayer;
    GroupBox1: TGroupBox;
    Otvori: TButton;
    Izlaz: TButton;
    CBPonavljaj: TCheckBox;
    ListaPesama: TListBox;
    OpenDialog1: TOpenDialog;
    Start: TButton;
    Pauza: TButton;
    Stop: TButton;
    Sledeca: TButton;
    TimerPoz: TTimer;
    PMListe: TPopupMenu;
    SnimiListu: TMenuItem;
    SaveDialog1: TSaveDialog;
    ObrisiIme: TMenuItem;
    Podaci: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    procedure OtvoriClick(Sender: TObject);
    procedure IzlazClick(Sender: TObject);
    procedure NotifyProc(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure PauzaClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure Lista;
    procedure SledecaClick(Sender: TObject);
    procedure TimerPozTimer(Sender: TObject);
    procedure ListaPesamaDblClick(Sender: TObject);
    procedure ListaPesamaKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SnimiListuClick(Sender: TObject);
    procedure ObrisiImeClick(Sender: TObject);
    procedure TrackBar1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TrackBar1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListaPesamaDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure TrackBar1Exit(Sender: TObject);
  private
    { Private declarations }
    TrackBarM: TTrackBarM;
    procedure UcitajPodatke(TagFajl: string);
  public
    { Public declarations }
  end;
  TMp3Tag = record
   ImePesme: string;
   Izvodjac: string;
   NazivAlbuma: string;
   Godina: string;
   Komentar: string;
   Vrsta: string;
  end;

var
  Form1: TForm1;
  Plejlista: TStringList;
  tekuca: integer = -1;

  procedure CitaTag(FajlIme: string; var Mp3Tag: TMp3Tag);

implementation

{$R *.dfm}

procedure CitaTag(FajlIme: string; var Mp3Tag: TMp3Tag);
 var ID3Engine: TID3Engine;
     lup: integer;
begin
 fillchar(Mp3Tag, SizeOf(TMp3Tag), #0);


 ID3Engine := TID3Engine.Create(Form1);
 try
  ID3Engine.FileName := FajlIme;
  ID3Engine.Active := true;
  for lup := 0 to ID3Engine.Frames.Count-1 do
   if ID3Engine.Frames.Items[lup].Name = 'TIT2' then begin
    if ID3Engine.Frames.Items[lup].AsText <> '' then
     Mp3Tag.ImePesme := ID3Engine.Frames.Items[lup].AsText;
   end else
   if ID3Engine.Frames.Items[lup].Name = 'TPE1' then begin
    if ID3Engine.Frames.Items[lup].AsText <> '' then
     Mp3Tag.Izvodjac := ID3Engine.Frames.Items[lup].AsText;
   end else
   if ID3Engine.Frames.Items[lup].Name = 'TALB' then begin
    if ID3Engine.Frames.Items[lup].AsText <> '' then
     Mp3Tag.NazivAlbuma := ID3Engine.Frames.Items[lup].AsText;
   end else
   if ID3Engine.Frames.Items[lup].Name = 'COMM' then begin
    if ID3Engine.Frames.Items[lup].AsText <> '' then
     Mp3Tag.Komentar := ID3Engine.Frames.Items[lup].AsText;
   end else
   if ID3Engine.Frames.Items[lup].Name = 'TYER' then begin
    if ID3Engine.Frames.Items[lup].AsText <> '' then
     Mp3Tag.Godina := ID3Engine.Frames.Items[lup].AsText;
   end else
   if ID3Engine.Frames.Items[lup].Name = 'TCON' then begin
    if ID3Engine.Frames.Items[lup].AsText <> '' then
     Mp3Tag.Vrsta := ID3Engine.Frames.Items[lup].AsText;
   end;

  ID3Engine.Active := false; 
 finally
  ID3Engine.Free;
 end;

 if pos(')', Mp3Tag.Vrsta) < length(Mp3Tag.Vrsta) then
  delete(Mp3Tag.Vrsta, 1, pos(')', Mp3Tag.Vrsta));

end;

procedure TTrackBarM.WMLButtonDown(var Message: TWMLButtonDown);
begin
 inherited;
 Promene := true;
end;

procedure TTrackBarM.WMLButtonUp(var Message: TWMLButtonUp);
 var pozn: integer;
begin
 inherited;

 Promene := false;
 if Form1.MediaPlayer1.Mode <> mpPlaying then exit;

 pozn := Position * (Form1.MediaPlayer1.Length div 100);
 if Form1.MediaPlayer1.Position <> pozn then begin
  Form1.MediaPlayer1.Stop;
  Form1.MediaPlayer1.Position := pozn;
  Form1.MediaPlayer1.Play;
 end;
end;

procedure TForm1.UcitajPodatke(TagFajl: string);
 var Mp3Tag: TMp3Tag;
begin
 Podaci.Clear;
 MediaPlayer1.FileName := '';
 CitaTag(TagFajl, Mp3Tag);
 Podaci.Lines.Add('Naziv: '+Mp3Tag.ImePesme);
 if Mp3Tag.Izvodjac <> '' then Podaci.Lines.Add('Izvodjac: '+Mp3Tag.Izvodjac);
 if Mp3Tag.NazivAlbuma <> '' then Podaci.Lines.Add('Album: '+Mp3Tag.NazivAlbuma);
 if Mp3Tag.Godina <> '' then Podaci.Lines.Add('Godina: '+Mp3Tag.Godina);
 if Mp3Tag.Komentar <> '' then Podaci.Lines.Add('Komentar: '+Mp3Tag.Komentar);
 if Mp3Tag.Vrsta <> '' then Podaci.Lines.Add('Vrsta: ' +  Mp3Tag.Vrsta);
end;

procedure TForm1.NotifyProc(Sender: TObject);
const
  ModeStr: array[TMPModes] of string = ('Nije spreman', 'Stop', 'Svira', 'Snima', 'Seeking', 'Pauza', 'Otvara');
  NotifiS: array[TMPNotifyValues] of string = ('Successful', 'Superseded', 'Aborted', 'Failure');
begin
   with Sender as TMediaPlayer do begin
     Form1.Caption := 'Muzika - '+ ModeStr[Mode];
     if NotifyValue <> nvSuccessful then
      Form1.Caption := Form1.Caption+' '+NotifiS[NotifyValue];
     case Mode of
       mpStopped: begin
        if TimerPoz.Enabled then begin
         Close;
         Lista;
         Play;
        end;
       end;
       mpPlaying: begin
        if Position = Length then
         Stop
        else
         Label1.Caption := IntToStr(Length div 60000) + ':' +
                           FormatFloat('0#', Round(Length / 1000) mod 60);
        TimerPoz.Enabled := true;
       end;
     end;
     Notify := True;
   end;
end;

procedure TForm1.OtvoriClick(Sender: TObject);
 var lup: integer;
begin
 if OpenDialog1.Execute then begin
  if UpperCase(ExtractFileExt(OpenDialog1.FileName)) = '.M3U' then begin
   ListaPesama.Items.LoadFromFile(OpenDialog1.FileName);
   Plejlista.Clear;
   tekuca := -1;
   if MediaPlayer1.Mode in [MPlayer.mpOpen, MPlayer.mpPaused, MPlayer.mpPlaying] then begin
    MediaPlayer1.Stop;
    MediaPlayer1.Position := 0;
   end;
   for lup := 0 to ListaPesama.Items.Count-1 do
    Plejlista.Add(ExtractFilePath(OpenDialog1.FileName)+
     ListaPesama.Items.Strings[lup]);
  end else
  if OpenDialog1.Files.Count > 1 then begin
   Plejlista.Assign(OpenDialog1.Files);
   ListaPesama.Items.Clear;
   tekuca := -1;
   if MediaPlayer1.Mode in [MPlayer.mpOpen, MPlayer.mpPaused, MPlayer.mpPlaying] then begin
    MediaPlayer1.Stop;
    MediaPlayer1.Position := 0;
   end;
   for lup := 0 to Plejlista.Count-1 do
    ListaPesama.Items.Strings[lup] := ExtractFileName(Plejlista.Strings[lup]);
  end else begin
   ListaPesama.Items.Add(ExtractFileName(OpenDialog1.FileName));
   Plejlista.Add(OpenDialog1.FileName);
  end;

  Start.Enabled:= true;
  Pauza.Enabled:= true;
  Stop.Enabled:= true;
  Sledeca.Enabled:= true;
 end;
end;

procedure TForm1.IzlazClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.StartClick(Sender: TObject);
begin
 MediaPlayer1.Notify := true;
 if (tekuca > -1)and(tekuca < ListaPesama.Count) then begin
  if not ListaPesama.Selected[tekuca] then begin
   tekuca := 0;
   while tekuca < ListaPesama.Count-1 do begin
    if ListaPesama.Selected[tekuca] then
     break;
    inc(tekuca);
   end;
   if not ListaPesama.Selected[tekuca] then
    tekuca := 0;
  end;
  ListaPesama.Selected[tekuca] := true;
  ListaPesama.Repaint;
  ListaPesama.SetFocus;
  UcitajPodatke(Plejlista.Strings[tekuca]);
  MediaPlayer1.FileName := Plejlista.Strings[tekuca];
 end else begin
  tekuca := 0;
  while tekuca < ListaPesama.Count-1 do begin
   if ListaPesama.Selected[tekuca] then
    break;
   inc(tekuca);
  end;
  if not ListaPesama.Selected[tekuca] then
   tekuca := -1
  else
   dec(tekuca);
  Lista;
 end;

 if MediaPlayer1.Mode <> MPlayer.mpOpen then MediaPlayer1.Open;
 MediaPlayer1.Play;
end;

procedure TForm1.PauzaClick(Sender: TObject);
begin
 MediaPlayer1.Pause;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
 TimerPoz.Enabled := false;
 if MediaPlayer1.Mode in [MPlayer.mpOpen, MPlayer.mpPaused, MPlayer.mpPlaying] then begin
  MediaPlayer1.Stop;
  MediaPlayer1.Position := 0;
 end;
end;

procedure TForm1.Lista;
begin
 if (not CBPonavljaj.Checked) or (tekuca = -1) then begin
  Inc(tekuca);
  if tekuca = ListaPesama.Items.Count then tekuca := 0;
 end;

 ListaPesama.Selected[tekuca] := true;
 ListaPesama.Repaint;
 ListaPesama.SetFocus;
 if MediaPlayer1.Mode = mpPlaying then Stop.Click;
 UcitajPodatke(Plejlista.Strings[tekuca]);
 MediaPlayer1.FileName := Plejlista.Strings[tekuca];
 if MediaPlayer1.Mode <> MPlayer.mpOpen then MediaPlayer1.Open;
end;

procedure TForm1.SledecaClick(Sender: TObject);
begin
 Lista;
 Start.Click;
end;

procedure TForm1.TimerPozTimer(Sender: TObject);
 var poz: integer;
begin
 if MediaPlayer1.Mode <> mpPlaying then exit;
 if not TrackBarM.Promene then begin
  TrackBarM.Position := MediaPlayer1.Position div (MediaPlayer1.Length div 100);
  poz := MediaPlayer1.Position;
 end else
  poz := (MediaPlayer1.Length div 100) * TrackBarM.Position;
 Label2.Caption := IntToStr(poz div 60000) + ':' + FormatFloat('0#', Round(poz / 1000) mod 60);
end;

procedure TForm1.ListaPesamaDblClick(Sender: TObject);
begin
 if Start.Enabled then begin
  Start.Click;
  ListaPesama.Repaint;
 end; 
end;

procedure TForm1.ListaPesamaKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then begin
  if Start.Enabled then begin
   Start.Click;
   ListaPesama.Repaint;
  end; 
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 MediaPlayer1.Notify := True;
 Plejlista := TStringList.Create;
 TrackBarM := TTrackBarM.Create(Form1);
 TrackBarM.Parent := Form1;
 TrackBarM.Max := 100;
 TrackBarM.Frequency := TrackBarM.Max div 100;
 TrackBarM.Height := 33;
 TrackBarM.Width := 241;
 TrackBarM.Left := 16;
 TrackBarM.Top := 360;
 TrackBarM.Promene := false;
 TrackBarM.OnKeyDown := TrackBar1KeyDown;
 TrackBarM.OnKeyUp := TrackBar1KeyUp;
 TrackBarM.OnExit := TrackBar1Exit;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Plejlista.Free;
 MediaPlayer1.Notify := false;
 if MediaPlayer1.Mode in [MPlayer.mpOpen, MPlayer.mpPaused, MPlayer.mpPlaying] then
  MediaPlayer1.Stop;
 TrackBarM.Free;
end;

procedure TForm1.SnimiListuClick(Sender: TObject);
 var dir: string;
begin
 if Plejlista.Count > 0 then
  dir := getcurrentdir
 else
  dir := '';
 if length(dir) > 0 then begin
  if dir[length(dir)] = '\' then delete(dir, length(dir), 1);
  SaveDialog1.FileName := ExtractFileName(dir)+'.m3u';
 end else
  SaveDialog1.FileName := 'lista.m3u';
 if SaveDialog1.Execute then
  ListaPesama.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.ObrisiImeClick(Sender: TObject);
begin
  if ListaPesama.Count = 0 then exit;
  if not ((tekuca > -1)and(tekuca < ListaPesama.Count)) then
   tekuca := 0;
  Stop.Click;

  if not ListaPesama.Selected[tekuca] then begin
   tekuca := 0;
   while tekuca < ListaPesama.Count-1 do begin
    if ListaPesama.Selected[tekuca] then
     break;
    inc(tekuca);
   end;
   if not ListaPesama.Selected[tekuca] then
    tekuca := 0;
  end;
  ListaPesama.Selected[tekuca] := true;
  if ListaPesama.Selected[tekuca] then begin
   ListaPesama.DeleteSelected;
   Plejlista.Delete(tekuca);
   if ListaPesama.Count = 0 then
    tekuca := -1
   else
   if tekuca >= ListaPesama.Count then begin
    tekuca := 0;
    ListaPesama.Selected[tekuca] := true;
   end;
  end;
  ListaPesama.Repaint;
  ListaPesama.SetFocus;
end;

procedure TForm1.TrackBar1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key in [VK_PRIOR..VK_DOWN] then
  TrackBarM.Promene := true;
end;

procedure TForm1.TrackBar1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
 var pozn: integer;
begin
 if Key in [VK_PRIOR..VK_DOWN] then
  TrackBarM.Promene := false
 else
  exit; 
 if Form1.MediaPlayer1.Mode <> mpPlaying then exit;

 pozn := TrackBarM.Position * (MediaPlayer1.Length div 100);
 if MediaPlayer1.Position <> pozn then begin
  MediaPlayer1.Stop;
  MediaPlayer1.Position := pozn;
  MediaPlayer1.Play;
 end;
end;

procedure TForm1.ListaPesamaDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var  Offset: Integer;
begin
  with (Control as TListBox).Canvas do begin
   FillRect(Rect);
   Offset := 2;
   if tekuca = Index then begin
    Brush.Color := clLime;
    Font.Color := clBlack;
   end;
   TextOut(Rect.Left + Offset, Rect.Top, (Control as TListBox).Items[Index]);
  end;
end;

procedure TForm1.TrackBar1Exit(Sender: TObject);
begin
 TrackBarM.Promene := false;
end;

end.
